import qualified Data.Map.Strict as M
import qualified Data.ByteString as BS
import Control.Monad.IO.Class
import Control.Concurrent.STM
import Network.MessagePackRpc.Server

rpcRead :: Ord k => TVar (M.Map k v) -> k -> Method (Maybe v)
rpcRead tm k = do
  m <- liftIO.atomically $ readTVar tm
  return $ M.lookup k m

rpcWrite :: Ord k => TVar (M.Map k v) -> k -> v -> Method ()
rpcWrite tm k v =
  liftIO.atomically $ modifyTVar' tm $
    M.insert k v

port :: Int
port = 1234

main :: IO ()
main = do
  tm <- newTVarIO (M.empty :: M.Map BS.ByteString BS.ByteString)
  putStrLn $ "Starting msgpack-rpc server on port " ++ show port
  serve port
    [ ("read", toMethod $ rpcRead tm)
    , ("write", toMethod $ rpcWrite tm)
    ]
